#! /usr/bin/env python

from MMTK import *
from MMTK.Minimization import ConjugateGradientMinimizer, SteepestDescentMinimizer
from MMTK.Trajectory import StandardLogOutput
from MMTK.Joiner import Joiner
import sys, string

from MMTK.ForceFields import Amber94ForceField

ff = Amber94ForceField()
world = InfiniteUniverse(ff)
ball_half = Group('buckyball1', configuration = 'default')

tube_length = string.atoi(sys.argv[1])
if tube_length > 0:
    tube_section = Group('buckytube')
    if tube_length == 1:
	tube = tube_section
    else:
	join = Joiner(tube_section)
	join.repeatGroup('hook1', 'hook2', tube_length)
	tube = join.getResult()

join = Joiner(ball_half)
if tube_length > 0:
    join.joinGroups(ball_half.hook2, tube.hook1)
    part1 = join.getIntermediateResult().hook2
else:
    part1 = ball_half.hook2
join.joinGroups(part1, ball_half.hook1)
result = join.getResult()
try:
    result.setPositions(ff)
except ConformationError, msg:
    print 'ConformationError',msg
else:
    world.group = result

    minimizer = ConjugateGradientMinimizer(world, actions=[StandardLogOutput(50)])
    minimizer(convergence = 1.e-3, steps = 20)

result.printBadDihedrals()
save(result,'resultb.mmtk')
from MMTK.ConfigIO import OutputFile
fmt = OutputFile('resultb.pdb', 'pdb_connect')
fmt.write(result)
fmt.close()

import MMTK.RasMol
ras_session = MMTK.RasMol.RasMol(result, 0, 1)
ras_session.Interact()
