# MMTK initialization
#
# Written by Konrad Hinsen
# last revision: 1999-3-3
#

#
# Add shared library path to sys.path
#
import os, sys
sys.path.append(os.path.join(os.path.split(__file__)[0], sys.platform))
del os
del sys


#
# General library modules, for convenience
#
from Scientific.Geometry import Vector
from Scientific.Geometry.Transformation import Translation, Rotation
from copy import copy, deepcopy
from sys import stdin, stdout, stderr

#
# MMTK core modules
#
from Universe import InfiniteUniverse, OrthorhombicPeriodicUniverse, \
                     CubicPeriodicUniverse
from Variables import ParticleScalar, ParticleVector, SymmetricPairTensor
from ChemicalObjects import Atom, Group, Molecule, Complex
from Collection import Collection, PartitionedCollection, \
                       PartitionedAtomCollection
from Utility import save, load
import Units

####################

##  from Protein import PeptideChain, Protein, waterFromPDBSequence, \
##                      unknownResiduesFromPDBSequence, defineResidue
##  from NucleicAcid import NucleotideChain
##  from Environment import NoseThermostat, AndersenBarostat

##  from Lattice import SCLattice
##  from Scientific.Geometry.Objects3D import Sphere, Plane, Cone, Circle, Line

##  from Field import AtomicScalarField, AtomicVectorField

##  from ConfigIO import PDBFile

##  from Utility import trajectoryInfo
##  from Visualization import view, viewMode, viewTrajectory, viewSequence

##  from ForceFieldTest import gradientTest, forceConstantTest

##  from ChargeFit import ChargeFit, TotalChargeConstraint, EqualityConstraint, \
##                        evaluationPoints

##  from Trajectory import Trajectory, SnapshotGenerator
##  from Minimization import ConjugateGradientMinimizer, SteepestDescentMinimizer
##  from Dynamics import VelocityVerletIntegrator, VelocityScaler, Heater, \
##                       BarostatReset, TranslationRemover, RotationRemover
##  from DCD import DCDReader, writeDCD, writeDCDPDB
##  from NormalModes import NormalModes, SubspaceNormalModes, \
##                          FiniteDifferenceSubspaceNormalModes, \
##  			SparseMatrixSubspaceNormalModes

##  import Solvent; del Solvent
##  from MMTK.Random import initializeRandomNumbersFromTime, \
##                          randomPointInBox, randomPointInSphere, \
##                          randomDirection, randomRotation, randomVelocity
