{
  double qiqj = charge[i]*charge[j]*electrostatic_energy_factor;
  double ef = 2./sqrt(M_PI);
  self->energy += qiqj*red/r;
  if (gradients != NULL || force_constants != NULL) {
    double deriv = -qiqj*(red/r+ef*beta*exp(-beta*beta*r_sq))/r_sq;
    if (gradients != NULL) {
      vector3 grad;
      grad[0] = deriv*rij[0];
      grad[1] = deriv*rij[1];
      grad[2] = deriv*rij[2];
      if (gradient_fn != NULL) {
	(*gradient_fn)(self, gradients, i, grad);
	vector_changesign(grad);
	(*gradient_fn)(self, gradients, j, grad);
      }
      else {
	vector3 *f = (vector3 *)((PyArrayObject *)gradients)->data;
	f[i][0] += grad[0];
	f[i][1] += grad[1];
	f[i][2] += grad[2];
	f[j][0] -= grad[0];
	f[j][1] -= grad[1];
	f[j][2] -= grad[2];
      }
    }
    if (force_constants != NULL) {
      double deriv2 = 2.*qiqj*(red/(r*r_sq) + 
                       ef*beta*exp(-beta*beta*r_sq)*(beta*beta+1./r_sq));
      add_pair_fc(self, force_constants, fc_fn, i, j,
		  rij, r_sq, deriv, deriv2);
    }
  }
}
