
extern "C"
{
#include <stdio.h>
#include <malloc.h>
#include "rasapi.h"
}

main(int argc, char **argv)
{
    ViewStruct bitmap;
    int drawwindow = argc > 1 && !strcmp(argv[1],"view");
    if(drawwindow)
      RasMolInit(NULL);
    else
    {
      bitmap.xmax = 500;
      bitmap.ymax = 300;
      bitmap.yskip = bitmap.xmax;
      bitmap.fbuf = (Pixel __huge *)_fmalloc(bitmap.yskip*bitmap.ymax + 32);
      bitmap.dbuf = 0;
      RasMolInit(&bitmap);
    }

    Molecule __far *Database = CreateMolGroup();
    Atom* h1 = CreateAtom();
    Atom* o = CreateAtom();
    Atom* h2 = CreateAtom();
    o->xorg = 2000;
    o->yorg = o->zorg = 1000;
    o->x = 2000;
    o->y = o->z = 1000;
    h1->xorg = 3000; h1->x = 3000;
    h1->yorg = 1500; h1->y = 1500;
    h1->zorg = h1->z = 1000;
    h2->xorg = 1000; h2->x = 1000;
    h2->yorg = 1500; h2->y = 1500;
    h2->zorg = h2->z = 1000;
	// arbitrary serial numbers:
    h1->serno = 1;
    o->serno = 2;
    h2->serno = 3;
    o->temp = h1->temp = h2->temp = 200;
    o->label = CreateLabel("O",1);
    h1->label = CreateLabel("H1",2);
    h2->label = CreateLabel("H2",2);
    h1->refno = SimpleAtomType("H ");
    h2->refno = SimpleAtomType("? ");
    o->refno = SimpleAtomType("O ");
    o->elemno = 8;
    h1->elemno = 1;
    h2->elemno = NO_ELEMENT_PRESENT;

    CreateBond(h1->serno, o->serno, NormBondFlag, Database);
    CreateBond(o->serno, h2->serno, NormBondFlag, Database);

    if(drawwindow)
    {
      RefreshScreen(Database);
      char *msg = RasMolInteract(Database);
      printf("RasMolInteract returned %s.\n",msg);
    }
    else
    {
      RasMolPaint(Database, &bitmap);
      fwrite(bitmap.fbuf, sizeof(*bitmap.fbuf), bitmap.yskip*bitmap.ymax,stdout);
    }
    RasMolExit();
}
